#include <iostream>
#include <vector>
#include <queue>
using namespace std;

typedef pair<int, int> CV; /// city, vinetki

const int MAXN = 83;
const int MAXM = 500;
const int MNOGO = 1e9;

int n, m;
bool sells[MAXN];
int G[MAXN][MAXN];

pair<int, int> dist[MAXN][2*MAXN]; /// dist to i with j vinetki : {dist, punktove}

void dijkstra(){
    for(int i = 1; i <= n; i++){
        for(int j = 0; j <= 2*n; j++){
            dist[i][j] = {MNOGO, 0};
        }
    }

    priority_queue<pair<pair<int, int>, CV>> pq;
    pq.push({{0, 0}, {1, 0}});
    while(!pq.empty()){
        int currd = -pq.top().first.first;
        int punkts = pq.top().first.second;
        CV curr = pq.top().second;
        pq.pop();

        if(sells[curr.first]){ curr.second++; }
        if(currd >= dist[curr.first][curr.second].first){ continue; }
        dist[curr.first][curr.second] = {currd, punkts};
        for(int i = 1; i <= n; i++){
            if(G[curr.first][i] != 0){
                /// bez izpolzvane na vinetka
                int newd = currd + G[curr.first][i];
                CV newCV = {i, curr.second};
                pq.push({{-newd, punkts+1}, newCV});
                /// s izpolzvane na vinetka, ako ima
                if(curr.second > 0){
                    int newd = currd;
                    CV newCV = {i, curr.second-1};
                    pq.push({{-newd, punkts+1}, newCV});
                }
            }
        }
    }
}

int main(){
    cin >> n >> m;
    for(int i = 1; i <= n; i++){
        cin >> sells[i];
    }
    for(int i = 0; i < m; i++){
        int a, b, t;
        cin >> a >> b >> t;
        G[a][b] = t;
    }

    dijkstra();
    int mni = 0;
    for(int i = 0; i <= 2*n; i++){
        if(dist[n][i].first < dist[n][mni].first){ mni = i; }
    }
    cout << dist[n][mni].first << ' ' << dist[n][mni].second << '\n';
    for(int i = 0; i < dist[n][mni].second; i++){
        cout << "1 0\n";
    }

    return 0;
}
