/********************************************
 *                                          *
 *   ISKAM PROSHKA OT BOG ZARADI TOZI KOD   *
 *                                          *
 ********************************************
 */
 // makar che i po-grozen sum pisal
#include <iostream>
#include <vector>
#include <queue>
#include <tuple>
using namespace std;

struct CVV{
    int city = 0;
    int used = 0;
    int avail = 0;
};
bool operator<(const CVV& a, const CVV& b){ return false; } /// prostotijka za da bachka priority_queue

const int MAXN = 83;
const int MAXM = 500;
const int MNOGO = 1e9;

int n, m;
bool sells[MAXN];
vector<pair<int, int>> G[MAXN][MAXN]; /// weight, edge No.

int dist[MAXN][MAXN][MAXN]; /// dist to i using j vinetki and having k left
CVV prv[MAXN][MAXN][MAXN];

void dijkstra(){
    for(int i = 1; i <= n; i++){
        for(int j = 0; j <= n; j++){
            for(int k = 0; k <= n; k++){
                dist[i][j][k] = MNOGO;
            }
        }
    }

    priority_queue<tuple<int, CVV, CVV>> pq;
    CVV start = {1, sells[1], 0};
    CVV invalid = {-1, -1, -1};
    pq.push({0, start, invalid}); /// stigame za 0 vreme do {grad: 1, izpolzvani: 0, imame: 0};
    while(!pq.empty()){
        int currd = -get<0>(pq.top());
        CVV curr = get<1>(pq.top());
        CVV previous = get<2>(pq.top());
        pq.pop();

        if(currd >= dist[curr.city][curr.used][curr.avail]){ continue; }
        dist[curr.city][curr.used][curr.avail] = currd;
        prv[curr.city][curr.used][curr.avail] = previous;
        for(int i = 1; i <= n; i++){
            if(G[curr.city][i].size() > 0){
                /// bez izpolzvane na vinetka
                for(int j = 0; j < G[curr.city][i].size(); j++){
                    int newd = currd + G[curr.city][i][j].first;
                    CVV newCVV = {i, curr.used, curr.avail + sells[i]};
                    pq.push({-newd, newCVV, curr});
                }
                /// s izpolzvane na vinetka, ako ima
                if(curr.avail > 0){
                    int newd = currd;
                    CVV newCVV = {i, curr.used+1, curr.avail + sells[i] - 1};
                    pq.push({-newd, newCVV, curr});
                }
            }
        }
    }
}

int main(){
    cin >> n >> m;
    for(int i = 1; i <= n; i++){
        cin >> sells[i];
    }
    for(int i = 1; i <= m; i++){
        int a, b, t;
        cin >> a >> b >> t;
        pair<int, int> edge = {t, i};
        G[a][b].push_back(edge);
    }

    dijkstra();
    int mni = 0, mnj = 0;
    for(int i = 0; i <= n; i++){
        for(int j = 0; j <= n; j++){
            if(dist[n][i][j] < dist[n][mni][mnj]){ mni = i; mnj = j; }
        }
    }

    vector<pair<int, int>> route;
    for(CVV curr = {n, mni, mnj}; curr.city != -1; curr = prv[curr.city][curr.used][curr.avail]){
        CVV nxt = prv[curr.city][curr.used][curr.avail];
        if(nxt.city != -1){
            route.push_back({G[nxt.city][curr.city][0].second, 1-(curr.used - nxt.used)});
        }
    }

    cout << dist[n][mni][mnj] << ' ' << route.size() << '\n';
    for(vector<pair<int, int>>::reverse_iterator it = route.rbegin(); it != route.rend(); ++it){
        cout << it->first << ' ' << it->second << '\n';
    }

    return 0;
}
