#include <iostream>

using namespace std;

typedef long long ll;

const int maxN = 5000100;
const int maxDiff = 5000100;
bool isPrime[maxN];
ll primes[maxN];
ll primesLen = 0;
ll lpd[maxDiff];
ll inputs[maxN];
int t;
ll minX = 10000000000000000;
ll maxX = -1;

ll firstOver(ll num, ll mod)
{
    if (num % mod == 0) return num;
    return num + mod - (num % mod);
}

bool isPrimeFast(ll a)
{
    for (ll i = primes[primesLen - 1]; i * i <= a; i++)
    {
        if (a % i == 0) return false;
    }
    return true;
}

ll findLpdFast(ll a)
{
    for (ll i = primes[primesLen - 1]; i * i <= a; i++)
    {
        if (maxN % i == 0)
        {
            if (isPrimeFast(i)) return i;
        }
    }

    return a;
}

int main()
{
    for (int i = 0; i < maxN; i++)
    {
        isPrime[i] = true;
    }
    for (int step = 2; step < maxN; step++)
    {
        if (!isPrime[step]) continue;
        for (int i = step * 2; i < maxN; i += step)
        {
            isPrime[i] = false;
        }
    }

    for (int i = 2; i < maxN; i++)
    {
        if (isPrime[i])
        {
            primes[primesLen] = i;
            primesLen++;
        }
    }

    for (int i = 0; i < maxDiff; i++)
    {
        lpd[i] = -1;
    }

    ll temp;
    while (cin >> temp)
    {
        inputs[t] = temp;
        t++;
        if (temp < minX) minX = temp;
        if (temp > maxX) maxX = temp;
    }

    for (int step = 0; step < primesLen; step++)
    {
//        cout << firstOver(minX, primes[step]) << endl;
        for (ll num = firstOver(minX, primes[step]); num <= maxX; num += primes[step])
        {
            if (lpd[num - minX] != -1) continue;
            lpd[num - minX] = primes[step];
        }
    }

    ll diff = maxX - minX;
    for (int i = 0; i < diff; i++)
    {
        if (lpd[i] == -1)
        {
            lpd[i] = findLpdFast(minX + i);
        }
    }

    for (int i = 0; i < t; i++)
    {
        cout << lpd[inputs[i] - minX] << endl;
    }

//    for (int i = 0; i <= 100; i++)
//    {
//        cout << i << "; " << i + minX << " ->" << lpd[i] << "; " << findLpd(minX + i) << endl;
//    }

//    cout << primesLen << endl;
//    cout << primes[primesLen - 1] << endl;
    return 0;
}

