#include <iostream>

using namespace std;

typedef long long ll;

const int maxN = 32000100;
const int maxDiff = 5000100;
ll lpd[maxDiff];
ll inputs[maxN];
int t;
ll minX = 10000000000000000;
ll maxX = -1;

bool isPrime[maxN];
ll primes[maxN];
ll primesLen = 0;

ll firstOver(ll num, ll mod)
{
    if (num % mod == 0) return num;
    return num + mod - (num % mod);
}

int main()
{
    for (int i = 0; i < maxN; i++)
    {
        isPrime[i] = true;
    }
    for (int step = 2; step < maxN; step++)
    {
        if (!isPrime[step]) continue;
        for (int i = step * 2; i <= maxN; i += step)
        {
            isPrime[i] = false;
        }
    }

    for (int i = 2; i < maxN; i++)
    {
        if (isPrime[i])
        {
            primes[primesLen] = i;
            primesLen++;
        }
    }

    for (int i = 0; i < maxDiff; i++)
    {
        lpd[i] = -1;
    }

    ll temp;
    while (cin >> temp)
    {
        inputs[t] = temp;
        t++;
        if (temp < minX) minX = temp;
        if (temp > maxX) maxX = temp;
    }

    for (int step = 0; primes[step] * primes[step] <= maxN; step++)
    {
//        if (primes[step] % 1000000 < 100) cout << primes[step] / 1000000 << endl;
        for (ll num = firstOver(minX, primes[step]); num <= maxX; num += primes[step])
        {
            if (lpd[num - minX] != -1) continue;
            lpd[num - minX] = primes[step];
        }
    }

    for (int i = 0; i < maxDiff; i++)
    {
        if (lpd[i] == -1)
        {
            lpd[i] = i + minX;
        }
    }

    for (int i = 0; i < t; i++)
    {
        cout << lpd[inputs[i] - minX] << endl;
    }
    return 0;
}
