#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 82;
const int INF = INT_MAX;
priority_queue <pair <int, int>> pq;
int dist[MAXN];
vector <pair <int, int>> graph[MAXN];
int parent[MAXN];

int Dijikstra(int start, int finish)
{

    for (int i = 0; i < MAXN; i++)
        dist[i] = INF;

    parent[start] = -1;
    dist[start] = 0;
    pq.push({-0, start});

    while (!pq.empty())
    {
        int currDist = -pq.top().first;
        int currNode = pq.top().second;

        pq.pop();


        if (dist[currNode] < currDist)
            continue;

        for (pair <int, int> next:graph[currNode])
        {

            if (dist[next.first] > currDist + next.second)
            {
                dist[next.first] = currDist + next.second;
                parent[next.first] = currNode;
                pq.push({-dist[next.first], next.first});
            }
        }
    }

    return dist[finish];
}

int s[MAXN];
int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);

    int N, M;
    cin >> N >> M;
    for (int i = 1; i <= N; i++)
        cin >> s[i];

    for (int i = 1; i <= M; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;

        graph[u].push_back({v, cost});
    }

    int T = Dijikstra(1, N);

    stack <int> ans;
    ans.push(N);

    while (ans.top() != 1)
    {
        ans.push(parent[ans.top()]);
    }
    ans.pop();

    cout << ans.size() << " " << T << endl;
    while (ans.empty() == false)
    {
        cout << ans.top() << " " << 1 << endl;
        ans.pop();
    }


    return 0;
}
