#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

struct Edge
{
    int v, cost, ind;
    Edge(){}
    Edge(int v, int cost, int ind)
        :v(v), cost(cost), ind(ind){}
};
const int MAXN = 82;
const int INF = INT_MAX;
priority_queue <pair <int, int>> pq;
int dist[MAXN];
vector <Edge> graph[MAXN];
pair <int, int> parent[MAXN];

int Dijikstra(int start, int finish)
{

    for (int i = 0; i < MAXN; i++)
        dist[i] = INF;

    parent[start] = {-1, -1};
    dist[start] = 0;
    pq.push({-0, start});

    while (!pq.empty())
    {
        int currDist = -pq.top().first;
        int currNode = pq.top().second;

        pq.pop();


        if (dist[currNode] < currDist)
            continue;

        for (Edge next:graph[currNode])
        {

            if (dist[next.v] > currDist + next.cost)
            {
                dist[next.v] = currDist + next.cost;
                parent[next.v] = {currNode, next.ind};
                pq.push({-dist[next.v], next.v});
            }
        }
    }

    return dist[finish];
}

int s[MAXN];
int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);

    int N, M;
    cin >> N >> M;
    for (int i = 1; i <= N; i++)
        cin >> s[i];

    for (int i = 1; i <= M; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;

        graph[u].emplace_back(v, cost, i);
    }

    int T = Dijikstra(1, N);

    stack <int> ans;
    int currNode = N;

    while (currNode != 1)
    {
        ans.push(parent[currNode].second);
        currNode = parent[currNode].first;
    }

    cout << T << " " << ans.size() << endl;
    while (ans.empty() == false)
    {
        cout << ans.top() << " " << 1 << endl;
        ans.pop();
    }


    return 0;
}
