#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

struct Edge
{
    int v, cost, ind;
    Edge(){}
    Edge(int v, int cost, int ind)
        :v(v), cost(cost), ind(ind){}
};
struct Parent
{
    int v, ind, used;
    Parent(){}
    Parent(int v, int ind, int used)
        :v(v), ind(ind), used(used){}
};
const int MAXN = 82;
const int MAXM = 502;
const int INF = INT_MAX;

int N, M;
vector <Edge> graph[MAXN];
int s[MAXN];
int dp[MAXN][MAXM][MAXN];
Parent parent[MAXN];
bool visited[MAXN];

int Solve(int curr, int edgeInd, int availableTolls)
{
    visited[curr] = true;
    availableTolls += s[curr];
    if (availableTolls > N)
        return INF;

    if (curr == N)
    {
        return 0;
    }


    if (dp[curr][edgeInd][availableTolls] != -1)
        return dp[curr][edgeInd][availableTolls];

    int ans = INF;
    Parent info;
    for (Edge i:graph[curr])
    {
        info = parent[i.v];
        if (availableTolls > 0)
        {
            if (ans > Solve(i.v, i.ind, availableTolls-1))
            {
                ans = Solve(i.v, i.ind, availableTolls-1);
                info = Parent(curr, i.ind, 0);
            }
        }

        if (ans > Solve(i.v, i.ind, availableTolls) + i.cost)
        {
            ans = Solve(i.v, i.ind, availableTolls) + i.cost;
            info = Parent(curr, i.ind, 1);
        }

        parent[i.v] = info;
    }

    dp[curr][edgeInd][availableTolls] = ans;
    visited[curr] = false;
    return ans;
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    memset(dp, -1, sizeof(dp));

    cin >> N >> M;
    for (int i = 1; i <= N; i++)
        cin >> s[i];

    for (int i = 1; i <= M; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;

        graph[u].emplace_back(v, cost, i);
    }

    cout << Solve(1, 0, 0);
    stack <pair <int, int>> ans;
    int currNode = N;

    while (currNode != 1)
    {
        ans.push({parent[currNode].ind, parent[currNode].used});
        currNode = parent[currNode].v;
    }

    cout << " " << ans.size() << endl;
    while (!ans.empty())
    {
        cout << ans.top().first << " " << ans.top().second << endl;
        ans.pop();
    }

    return 0;
}

/*
4 5
0 0 1 0
1 2 3
1 3 1
3 2 1
2 4 3
3 4 6
*/
