#include <iostream>
#include <chrono>
#include <vector>
#include <stack>

#define maxn 1000005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;


using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

int n;
int sieve[maxn];

void _sieve(int n)
{
    for(int i = 2; i <= n; i++)
    {
        if(sieve[i] == 0)
        {
            sieve[i] = i;
            for(int j = i; j <= n; j += i)
            {
                if(sieve[j] == 0) sieve[j] = i;
            }
        }
    }
}

int t;

int find_factor(int n)
{

    if(n % 2 == 0) return 2;

    for(int i = 3; i * i <= n; i += 2)
    {
        if(n % i == 0) return i;
    }

    return n;

}

void solve()
{
    _sieve(1e6 + 1);

    ///cin >> t;
    while( cin >> n )
    {
        //cin >> n;
        ///cout << sieve[n] << endl;

        cout << find_factor(n) << endl;

    }

}


int main()
{

#ifdef ONLINE_JUDGE
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    startT = std::chrono::high_resolution_clock::now();

    solve();


    return 0;
}
