#include <iostream>
#include <chrono>
#include <vector>
#include <stack>
#include <assert.h>
#include <map>
#include <cmath>

#define maxn 50000005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;


using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

long long n;

long long find_factor(long long n)
{

    if(n % 2 == 0) return 2;

    for(int i = 3; (long long)(i * i) <= n; i += 2)
    {
        if(n % i == 0) return i;
    }

    return n;

}

vector <int> prime;
int sieve[maxn];
vector <int> numbers;

void _sieve(int n)
{
    for(int i = 2; i <= n; i++)
    {
        if(sieve[i] == 0)
        {

            prime.pb(i);

            sieve[i] = i;
            for(int j = i; j <= n; j += i)
            {
                if(sieve[j] == 0) sieve[j] = i;
            }
        }
    }
}

long long minn = LINF;
long long maxx = -LINF;

map <int , int> used;
int ans[maxn];

void solve()
{
    double to = 1;
    for(int i = 1; i <= 15; i++) to *= 10;
    to = ceil(sqrt(to));

    ///cout << "-> " << to << endl;


    ///cin >> t;
    while( cin >> n )
    {
        if(n > maxx) maxx = n;
        if(minn > n) minn = n;
        numbers.pb(n);
    }

    if(maxx < 1000000000000)
    {
        for(int c : numbers) cout << find_factor(c) << endl;
        return;
    }
    else
    {

        _sieve(to);

        for(int cur : prime)
        {

            int start = (minn / cur);

            if(minn % cur != 0) start++;
            start *= cur;

            for(int j = start; j <= maxx; j += cur)
            {
                if(ans[j - minn] == 0) ans[j - minn] = cur;
            }
        }

        for(int e : numbers) cout << ans[e - minn] << endl;

    }

}


int main()
{

/**#ifdef ONLINE_JUDGE
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif*/

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ///startT = std::chrono::high_resolution_clock::now();

    solve();


    return 0;
}
