#include <iostream>
#include <chrono>
#include <vector>
#include <stack>
#include <queue>
#include <cstring>

#define maxn 100005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;


using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

struct edge
{
    int to, cost;
    edge() {};
    edge(int to2, int cost2)
    {
        to = to2;
        cost = cost2;
    }
};


int n, m;

bool can[maxn];
vector <edge> v[maxn];

void read()
{
    cin >> n >> m;

    for(int i = 1; i <= n; i++) cin >> can[i];

    int from, to, cost;

    for(int i = 1; i <= m; i++)
    {
        cin >> from >> to >> cost;

        v[from].push_back({to, cost});

    }

}

int rec[maxn];
unsigned int d[maxn];
bool used[maxn];
int br[maxn];
vector <int> path;

void dijkstra(int start)
{
    memset(d, -1, sizeof(d));
    d[start] = 0;
    priority_queue <pair <int, int> > q;
    q.push({0, start});
    rec[start] = -1;

    while(q.empty() == false)
    {

        pair <int, int> e = q.top();
        q.pop();


        for(edge nb : v[e.Y])
        {
            if(d[nb.to] > d[e.Y] + nb.cost)
            {
                d[nb.to] = d[e.Y] + nb.cost;
                q.push({nb.cost, nb.to});
                br[nb.to] = br[e.Y] + 1;
                rec[nb.to] = e.Y;

            }
        }
    }

    int cur = n;

    while(true)
    {
        path.pb(cur);
        cur = rec[cur];

        if(cur == -1) break;

    }

    /**for(int e : path) cout << e << " ";
    cout << endl;*/

}

void solve()
{
    dijkstra(1);

    /**for(int i = 1; i <= n; i++) cout << d[i] << " ";
    cout << endl;*/

    cout << d[n] << " " << br[n] << endl;

    for(int i = path.size() - 1; i > -1; i--) cout << path[i] << " " << 0 << endl;


}

int main()
{

#ifdef ONLINE_JUDGE
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    startT = std::chrono::high_resolution_clock::now();

    read();
    solve();


    return 0;
}
