#include <iostream>
#include <chrono>
#include <vector>
#include <stack>
#include <queue>
#include <cstring>

#define maxn 85
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;


using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

struct edge
{
    int to, cost;
    edge() {};
    edge(int to2, int cost2)
    {
        to = to2;
        cost = cost2;
    }
};


int n, m;

bool can[maxn];
vector <edge> v[maxn];
int order[maxn][maxn];
int minn[maxn][maxn];

void read()
{
    cin >> n >> m;

    for(int i = 1; i <= n; i++) for(int j = 1; j <= n; j++) minn[i][j] = INF;

    for(int i = 1; i <= n; i++) cin >> can[i];

    int from, to, cost;

    for(int i = 1; i <= m; i++)
    {
        cin >> from >> to >> cost;

        if(cost < minn[from][to])
        {
            order[from][to] = i;
            minn[from][to] = cost;
        }
        v[from].push_back({to, cost});

    }

}

int rec[maxn][maxn];
unsigned int d[maxn][maxn];
bool used[maxn];
int br[maxn][maxn];
vector <int> path;

struct pom
{
    int w, to, br;
    pom() {};
    pom(int w2, int to2, int br2)
    {
        w = w2;
        to = to2;
        br = br2;
    }

    bool operator <(const pom &e)const
    {
        return w < e.w;
    }


};



void dijkstra(int start)
{
    memset(d, -1, sizeof(d));
    d[0][start] = 0;
    priority_queue <pom> q;
    if(can[start] == false) q.push({0, start, 0});
    else q.push({0 , start , 1});

    for(int i = 0; i < maxn; i++) rec[i][start] = -1;
    for(int i = 0; i < maxn; i++)  br[i][start] = d[i][start] = 0;

    while(q.empty() == false)
    {

        pom e = q.top();
        q.pop();

        if(can[e.to] == 1)
        {

            ///cout << "kanmd" << endl;

            ///e.br++;
        }

        for(edge nb : v[e.to])
        {
            if(d[e.br][nb.to] > d[e.br][e.to] + nb.cost)
            {

                if(can[nb.to] == true)
                {
                    d[e.br + 1][nb.to] = d[e.br][e.to] + nb.cost;
                    br[e.br + 1][nb.to] = br[e.br][e.to] + 1;
                    
                    int dd = min(e.br + 1 , n);
                    
                    q.push({nb.cost, nb.to, dd});
                }
                else
                {
                    d[e.br][nb.to] = d[e.br][e.to] + nb.cost;
                    br[e.br][nb.to] = br[e.br][e.to] + 1;
                    q.push({nb.cost, nb.to, e.br});
                }


            }

            if(e.br > 0 && d[e.br - 1][nb.to] > d[e.br][e.to])
            {

                ///cout << "aosidnkad" << endl;

                if(can[nb.to] == true)
                {
                    d[e.br][nb.to] = d[e.br][e.to];
                    br[e.br][nb.to] = br[e.br][e.to] + 1;
                    
                    int dd = min(n , e.br);
                    
                    q.push({nb.cost, nb.to, dd});
                }
                else
                {
                    d[e.br - 1][nb.to] = d[e.br][e.to];
                    br[e.br - 1][nb.to] = br[e.br][e.to] + 1;
                    
                    ////int dd = min(n , e.br + 1);
                    
                    q.push({nb.cost, nb.to, e.br - 1});
                }

            }

        }

    }

    /**int cur = n;

    while(true)
    {
        path.pb(cur);
        cur = rec[cur];

        if(cur == -1) break;

    }*/

    /**for(int e : path) cout << e << " ";
    cout << endl;*/

}

void solve()
{
    dijkstra(1);

    /**for(int i = 1; i <= n; i++) cout << d[i] << " ";
    cout << endl;*/

    int ans = INF;
    int c;
    for(int i = 0; i < maxn; i++)
    {

        ///cout << d[i][n] << endl;

        if(ans > d[i][n])
        {
            ans = d[i][n];
            c = i;
        }
    }

    cout << ans << " " << br[c][n] << endl;

    for(int i = path.size() - 1; i > 0; i--) cout << order[path[i]][path[i - 1]] << " " << 1 << endl;


}

int main()
{

#ifdef ONLINE_JUDGE
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    startT = std::chrono::high_resolution_clock::now();

    read();
    solve();


    return 0;
}
