#include <iostream>
#include <chrono>
#include <vector>

#define maxn 100005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;

#pragma GCC optimize("O3" , "Ofast" , "fast-math" , "unroll-loops")
#pragma GCC target(avx2)

using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}


int n , q;

int a[maxn];

void read()
{
    cin >> n >> q;

    for(int i = 1; i <= n; i++) cin >> a[i];

}

vector <int> pos;

int ans_query(int val1 , int val2)
{

    pos.clear();

    for(int i = 1; i <= n; i++) if(a[i] == val1 || a[i] == val2) pos.push_back(i);

    int last = 1;
    int min_cost = INF;
    int cur_cost = 0;

    for(int start_pos = 1; start_pos <= n; start_pos++)
    {
        cur_cost = 0;

        last = start_pos;
        if(pos.size() + start_pos - 1 > n) break;

        for(int i = 0; i < pos.size(); i++)
        {
            cur_cost += abs(pos[i] - last);
            last++;
        }

        min_cost = min(cur_cost , min_cost);

    }

    return min_cost;

}

void solve()
{
    int x , y;

    for(int i = 1; i <= q; i++)
    {
        cin >> x >> y;

        cout << ans_query(x , y) << endl;

    }

}

int main()
{

#ifdef ONLINE_JUDGE
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    startT = std::chrono::high_resolution_clock::now();

    read();
    solve();


    return 0;
}
